<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/Integration/include/Integration/TestDirectiveHandler.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_eecb7863cc5539e333a9a51474f7e532.html">Integration</a></li><li class="navelem"><a class="el" href="dir_d487033c4cf6e1e6824ef2db7b280e3e.html">include</a></li><li class="navelem"><a class="el" href="dir_84c9947eba37dd4948f5fc1406e22cb3.html">Integration</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">TestDirectiveHandler.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_test_directive_handler_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_INTEGRATION_INCLUDE_INTEGRATION_TESTDIRECTIVEHANDLER_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_INTEGRATION_INCLUDE_INTEGRATION_TESTDIRECTIVEHANDLER_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;condition_variable&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;future&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;fstream&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;deque&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &lt;unordered_map&gt;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_directive_handler_interface_8h.html">AVSCommon/SDKInterfaces/DirectiveHandlerInterface.h</a>&quot;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_attachment_manager_8h.html">AVSCommon/AVS/Attachment/AttachmentManager.h</a>&quot;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_j_s_o_n_utils_8h.html">AVSCommon/Utils/JSON/JSONUtils.h</a>&quot;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">using namespace </span><a class="code" href="namespacealexa_client_s_d_k_1_1avs_common.html">alexaClientSDK::avsCommon</a>;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keyword">namespace </span>integration {</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">namespace </span>test {</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler.html">   42</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler.html">TestDirectiveHandler</a> : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html">avsCommon::sdkInterfaces::DirectiveHandlerInterface</a> {</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler.html">TestDirectiveHandler</a>(<a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a2c1f3500cf37d70ffd6c1067f9c7f921">avsCommon::avs::DirectiveHandlerConfiguration</a> config);</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keywordtype">void</span> handleDirectiveImmediately(std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt; directive) <span class="keyword">override</span>;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordtype">void</span> preHandleDirective(</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt; directive,</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        std::unique_ptr&lt;avsCommon::sdkInterfaces::DirectiveHandlerResultInterface&gt; result) <span class="keyword">override</span>;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordtype">bool</span> handleDirective(<span class="keyword">const</span> std::string&amp; messageId) <span class="keyword">override</span>;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keywordtype">void</span> cancelDirective(<span class="keyword">const</span> std::string&amp; messageId) <span class="keyword">override</span>;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a2c1f3500cf37d70ffd6c1067f9c7f921">avsCommon::avs::DirectiveHandlerConfiguration</a> getConfiguration() <span class="keyword">const override</span>;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keywordtype">void</span> onDeregistered() <span class="keyword">override</span>;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html">   69</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html">DirectiveParams</a> {</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html">DirectiveParams</a>();</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#aeccced36637b348e1aafd70e89be4a3f">   81</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#aeccced36637b348e1aafd70e89be4a3f">isUnset</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;            <span class="keywordflow">return</span> Type::UNSET == type;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        }</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#a4c028ea1a50eac8bd84d110cdc3fbeae">   90</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#a4c028ea1a50eac8bd84d110cdc3fbeae">isHandleImmediately</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            <span class="keywordflow">return</span> Type::HANDLE_IMMEDIATELY == type;</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        }</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#a25d9874a6d611fed1297f5d0b7404495">   99</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#a25d9874a6d611fed1297f5d0b7404495">isPreHandle</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            <span class="keywordflow">return</span> Type::PREHANDLE == type;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        }</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#adc338154f4839a22e6fa8a7f45d7be61">  108</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#adc338154f4839a22e6fa8a7f45d7be61">isHandle</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;            <span class="keywordflow">return</span> Type::HANDLE == type;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        }</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#a853e2f879162679774dc2bcd4edebfc9">  117</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#a853e2f879162679774dc2bcd4edebfc9">isCancel</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;            <span class="keywordflow">return</span> Type::CANCEL == type;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        }</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;</div><div class="line"><a name="l00126"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#adeed54ec6266bc934b7f489156d39b3c">  126</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#adeed54ec6266bc934b7f489156d39b3c">isTimeout</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;            <span class="keywordflow">return</span> <a class="code" href="namespacealexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1test.html#a6c6cde531b85c7fb8e6629ef0c2f5a27">Type::TIMEOUT</a> == type;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        }</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        <span class="comment">// Enum for the way the directive was passed to DirectiveHandler.</span></div><div class="line"><a name="l00131"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#ae29f7af67e830c57e7eef7ff0418e640">  131</a></span>&#160;        <span class="keyword">enum class</span> <a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#ae29f7af67e830c57e7eef7ff0418e640">Type</a> {</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;            <span class="comment">// Not yet set.</span></div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;            UNSET,</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;            <span class="comment">// Set when handleDirectiveImmediately is called.</span></div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;            HANDLE_IMMEDIATELY,</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;            <span class="comment">// Set when preHandleDirective is called.</span></div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;            PREHANDLE,</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;            <span class="comment">// Set when handleDirective is called.</span></div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;            HANDLE,</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;            <span class="comment">// Set when cancelDirective is called.</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;            CANCEL,</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;            <span class="comment">// Set when waitForNext times out waiting for a directive.</span></div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;            <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2.html#a31cdf3a4381c8885296ba2097263282ea070a0fb40f6c308ab544b227660aadff">TIMEOUT</a></div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        };</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        <span class="comment">// Type of how the directive was passed to DirectiveHandler.</span></div><div class="line"><a name="l00147"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#ab087e2b9c193560ce101f179f2e9903e">  147</a></span>&#160;        <a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#ae29f7af67e830c57e7eef7ff0418e640">Type</a> <a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#ab087e2b9c193560ce101f179f2e9903e">type</a>;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="comment">// AVSDirective passed from the Directive Sequencer to the DirectiveHandler.</span></div><div class="line"><a name="l00149"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#acdb1552207d6f0be449a0857bca6e2f7">  149</a></span>&#160;        std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt; <a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#acdb1552207d6f0be449a0857bca6e2f7">directive</a>;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        <span class="comment">// DirectiveHandlerResult to inform the Directive Sequencer a directive has either successfully or</span></div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;        <span class="comment">// unsuccessfully handled.</span></div><div class="line"><a name="l00152"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#af921122db7d611510b7e743bceaf3907">  152</a></span>&#160;        std::shared_ptr&lt;avsCommon::sdkInterfaces::DirectiveHandlerResultInterface&gt; <a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#af921122db7d611510b7e743bceaf3907">result</a>;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    };</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html">DirectiveParams</a> waitForNext(<span class="keyword">const</span> std::chrono::seconds duration);</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    std::mutex m_mutex;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    std::condition_variable m_wakeTrigger;</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    std::deque&lt;DirectiveParams&gt; m_queue;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    std::unordered_map&lt;std::string, std::shared_ptr&lt;avsCommon::sdkInterfaces::DirectiveHandlerResultInterface&gt;&gt;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        m_results;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    std::unordered_map&lt;std::string, std::shared_ptr&lt;avsCommon::avs::AVSDirective&gt;&gt; m_directives;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a2c1f3500cf37d70ffd6c1067f9c7f921">avsCommon::avs::DirectiveHandlerConfiguration</a> m_configuration;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;};</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;}  <span class="comment">// namespace test</span></div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;}  <span class="comment">// namespace integration</span></div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_INTEGRATION_INCLUDE_INTEGRATION_TESTDIRECTIVEHANDLER_H_</span></div><div class="ttc" id="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params_html_ae29f7af67e830c57e7eef7ff0418e640"><div class="ttname"><a href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#ae29f7af67e830c57e7eef7ff0418e640">alexaClientSDK::integration::test::TestDirectiveHandler::DirectiveParams::Type</a></div><div class="ttdeci">Type</div><div class="ttdef"><b>Definition:</b> TestDirectiveHandler.h:131</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_html"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common.html">alexaClientSDK::avsCommon</a></div><div class="ttdef"><b>Definition:</b> MockHTTP2Connection.cpp:19</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1test_html_a6c6cde531b85c7fb8e6629ef0c2f5a27"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1test.html#a6c6cde531b85c7fb8e6629ef0c2f5a27">alexaClientSDK::applicationUtilities::androidUtilities::test::TIMEOUT</a></div><div class="ttdeci">static constexpr std::chrono::milliseconds TIMEOUT</div><div class="ttdoc">Reader timeout. </div><div class="ttdef"><b>Definition:</b> AndroidSLESMicrophoneTest.cpp:40</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params_html_ab087e2b9c193560ce101f179f2e9903e"><div class="ttname"><a href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#ab087e2b9c193560ce101f179f2e9903e">alexaClientSDK::integration::test::TestDirectiveHandler::DirectiveParams::type</a></div><div class="ttdeci">Type type</div><div class="ttdef"><b>Definition:</b> TestDirectiveHandler.h:147</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2_html_a31cdf3a4381c8885296ba2097263282ea070a0fb40f6c308ab544b227660aadff"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1http2.html#a31cdf3a4381c8885296ba2097263282ea070a0fb40f6c308ab544b227660aadff">alexaClientSDK::avsCommon::utils::http2::HTTP2ResponseFinishedStatus::TIMEOUT</a></div><div class="ttdoc">Receipt of the response was not completed due to a timeout. </div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler.html">alexaClientSDK::integration::test::TestDirectiveHandler</a></div><div class="ttdef"><b>Definition:</b> TestDirectiveHandler.h:42</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html">alexaClientSDK::integration::test::TestDirectiveHandler::DirectiveParams</a></div><div class="ttdef"><b>Definition:</b> TestDirectiveHandler.h:69</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params_html_a853e2f879162679774dc2bcd4edebfc9"><div class="ttname"><a href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#a853e2f879162679774dc2bcd4edebfc9">alexaClientSDK::integration::test::TestDirectiveHandler::DirectiveParams::isCancel</a></div><div class="ttdeci">bool isCancel() const</div><div class="ttdef"><b>Definition:</b> TestDirectiveHandler.h:117</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_a2c1f3500cf37d70ffd6c1067f9c7f921"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#a2c1f3500cf37d70ffd6c1067f9c7f921">alexaClientSDK::avsCommon::avs::DirectiveHandlerConfiguration</a></div><div class="ttdeci">std::unordered_map&lt; NamespaceAndName, BlockingPolicy &gt; DirectiveHandlerConfiguration</div><div class="ttdef"><b>Definition:</b> DirectiveHandlerConfiguration.h:32</div></div>
<div class="ttc" id="_directive_handler_interface_8h_html"><div class="ttname"><a href="_directive_handler_interface_8h.html">DirectiveHandlerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params_html_adeed54ec6266bc934b7f489156d39b3c"><div class="ttname"><a href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#adeed54ec6266bc934b7f489156d39b3c">alexaClientSDK::integration::test::TestDirectiveHandler::DirectiveParams::isTimeout</a></div><div class="ttdeci">bool isTimeout() const</div><div class="ttdef"><b>Definition:</b> TestDirectiveHandler.h:126</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params_html_af921122db7d611510b7e743bceaf3907"><div class="ttname"><a href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#af921122db7d611510b7e743bceaf3907">alexaClientSDK::integration::test::TestDirectiveHandler::DirectiveParams::result</a></div><div class="ttdeci">std::shared_ptr&lt; avsCommon::sdkInterfaces::DirectiveHandlerResultInterface &gt; result</div><div class="ttdef"><b>Definition:</b> TestDirectiveHandler.h:152</div></div>
<div class="ttc" id="_j_s_o_n_utils_8h_html"><div class="ttname"><a href="_j_s_o_n_utils_8h.html">JSONUtils.h</a></div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params_html_a4c028ea1a50eac8bd84d110cdc3fbeae"><div class="ttname"><a href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#a4c028ea1a50eac8bd84d110cdc3fbeae">alexaClientSDK::integration::test::TestDirectiveHandler::DirectiveParams::isHandleImmediately</a></div><div class="ttdeci">bool isHandleImmediately() const</div><div class="ttdef"><b>Definition:</b> TestDirectiveHandler.h:90</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params_html_a25d9874a6d611fed1297f5d0b7404495"><div class="ttname"><a href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#a25d9874a6d611fed1297f5d0b7404495">alexaClientSDK::integration::test::TestDirectiveHandler::DirectiveParams::isPreHandle</a></div><div class="ttdeci">bool isPreHandle() const</div><div class="ttdef"><b>Definition:</b> TestDirectiveHandler.h:99</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_directive_handler_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::DirectiveHandlerInterface</a></div><div class="ttdef"><b>Definition:</b> DirectiveHandlerInterface.h:39</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params_html_adc338154f4839a22e6fa8a7f45d7be61"><div class="ttname"><a href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#adc338154f4839a22e6fa8a7f45d7be61">alexaClientSDK::integration::test::TestDirectiveHandler::DirectiveParams::isHandle</a></div><div class="ttdeci">bool isHandle() const</div><div class="ttdef"><b>Definition:</b> TestDirectiveHandler.h:108</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params_html_acdb1552207d6f0be449a0857bca6e2f7"><div class="ttname"><a href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#acdb1552207d6f0be449a0857bca6e2f7">alexaClientSDK::integration::test::TestDirectiveHandler::DirectiveParams::directive</a></div><div class="ttdeci">std::shared_ptr&lt; avsCommon::avs::AVSDirective &gt; directive</div><div class="ttdef"><b>Definition:</b> TestDirectiveHandler.h:149</div></div>
<div class="ttc" id="_attachment_manager_8h_html"><div class="ttname"><a href="_attachment_manager_8h.html">AttachmentManager.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params_html_aeccced36637b348e1aafd70e89be4a3f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1integration_1_1test_1_1_test_directive_handler_1_1_directive_params.html#aeccced36637b348e1aafd70e89be4a3f">alexaClientSDK::integration::test::TestDirectiveHandler::DirectiveParams::isUnset</a></div><div class="ttdeci">bool isUnset() const</div><div class="ttdef"><b>Definition:</b> TestDirectiveHandler.h:81</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
